Bug 1270672 - [DOCS] [7.2] [Feature] Update Managing Storage for Docker Formatted Containers
[DOCS] [7.2] [Feature] Update Managing Storage for Docker Formatted Containers
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: doc-RHEL-Atomic (Show other bugs)
7.1
Unspecified Unspecified
high Severity medium
: rc
: 7.2
Assigned To: Thien-Thi Nguyen
Vikram Goyal
Vikram Goyal
: Documentation
Depends On: 1249168 1267555
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-12 02:18 EDT by Vikram Goyal
Modified: 2016-08-04 21:27 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-11-19 19:46:32 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Vikram Goyal 2015-10-12 02:18:45 EDT
Update topic [1] with information about how Docker formatted container storage has changed to make use of direct-lvm or overlayfs.

This bug is part of the engineering work to track the changes [2].

[1] https://access.redhat.com/documentation/en/red-hat-enterprise-linux-atomic-host/version-7/getting-started-with-containers/#managing_storage_with_docker_formatted_containers

[2] https://bugzilla.redhat.com/show_bug.cgi?id=1259679
Comment 2 Thien-Thi Nguyen 2015-11-02 19:52:51 EST
Hi Stephen,

I'm writing you (referenced in [2] in  the description above) to enquire about the use of direct-lvm and overlayfs in the docker storage setup, as it pertains to AH 7.2.  As preliminary research, i've briefly read:

 http://developerblog.redhat.com/2014/09/30/overview-storage-scalability-docker/

Could you please comment on its accuracy?
Comment 3 Stephen Tweedie 2015-11-03 07:37:54 EST
Hi,

(In reply to Thien-Thi Nguyen from comment #2)

> I'm writing you (referenced in [2] in  the description above) to enquire
> about the use of direct-lvm and overlayfs in the docker storage setup, as it
> pertains to AH 7.2.  As preliminary research, i've briefly read:
> 
>  http://developerblog.redhat.com/2014/09/30/overview-storage-scalability-
> docker/
> 
> Could you please comment on its accuracy?

It is not exactly inaccurate, just old --- over a year old, which qualifies as ancient in docker years!  overlayfs was not available for us at the time that was written --- it's new in 7.2.

Can you work with the docker-storage-setup maintainer, Vivek Goyal, for info here?  I'm adding him to the BZ.  Thanks!
Comment 4 Vivek Goyal 2015-11-03 09:19:24 EST
Thein,

The article you referenced is more about comparing performance of various storage backends. 

Following is the article which should be referenced to figure out how to configure storage for docker on rhel as well as atomic host.

https://access.redhat.com/articles/1492923

This article already has details about how to configure lvm thin pool. We need to add details of how to configure overlay.

Yoana Ruseva <yruseva@redhat.com> is already looking into adding overlay details to the article.
Comment 5 Thien-Thi Nguyen 2015-11-11 18:13:07 EST
Related BZs (both assigned to yruseva): 1249168, 1267555

Per meeting w/ yruseva, we have partitioned the work:
- yruseva to document how to enable overlayfs for docker in various ways
- tnguyen to document an overview of overlayfs advantages (why use it?)
Comment 6 Thien-Thi Nguyen 2015-11-12 04:11:34 EST
(In reply to Vivek Goyal from comment #4)

> [see] https://access.redhat.com/articles/1492923
>
> Yoana Ruseva <yruseva@redhat.com> is already looking into adding overlay
> details to the article.

Great.  Thanks for the pointer.  (BTW, please spell my name as "Thien-Thi".  Spelling it "Thein" is like spelling your name "Viev", both incorrect in vowel order and incomplete.)

I gather that both LVM thin pool and OverlayFS do the "usual" copy-on-write magic.  However, the primary feature that recommends OverlayFS over LVM thin pool is its support for page-cache sharing between snapshot volumes.
 (a) Is that correct?
 (b) Are there other compelling reasons to use OverlayFS over LVM thin pool?

Thanks again for your help in this documentation effort.
Comment 8 Vivek Goyal 2015-11-16 10:20:07 EST
Overall section 8.6 looks good. Some brief comments.

8.6. OverlayFS support

#comment: Instead of OverlayFS support, will it be better to call it just
 "Overlay Graph Driver"

OverlayFS is a copy-on-write union file system that features page-cache sharing between snapshot volumes. Similarly to LVM thin pool, OverlayFS supports efficient storage of image layers. However, compared to LVM thin pool, container creation and destruction with OverlayFS uses less memory and is more performant. 

#comment: Above talks about only the pros and has not specified any downside of
 of using overlayfs. I think it is important to mention that overlayfs is
very new, does not support selinux yet and some of the file systems semantics
are different from standard filesystmes like ext4 and xfs. Hence one needs to
run their applications with overlayfs and make sure applications are fine with some of the new behavior. Following is a link to the non-standardard behavior of overlayfs.

https://github.com/torvalds/linux/blob/master/Documentation/filesystems/overlayfs.txt#L179
Comment 9 Thien-Thi Nguyen 2015-11-16 11:53:44 EST
Thanks Vivek.  The intro blurb has been updated (see above for links) per your suggestions.  WDYT?
Comment 10 Vivek Goyal 2015-11-17 08:10:00 EST
Looks good to me. Thanks.

Note You need to log in before you can comment on or make changes to this bug.